#!/usr/bin/perl -w

use strict;
use warnings;
use Getopt::Std;
my $count=0;
my %decl=();
my %tag=();
my %options=();


getopt('p:s:',\%options);

my $prefix=$options{p} || "na_jump";
my $stubs=$options{d} || "na_stub";


while (<>){
  if (m|void\s+(\w+)\b.*/\*NA_FUNC\*/|){
    $decl{$1}=$_	if (!defined($decl{$1}));
  }
}

my @name=sort keys %decl;

open(H,">$prefix.h") || die;

print H '#define TAG(suf) _TAG(suf)
#define _TAG(suf) TAG_##suf
#include "nalloc.h"
';
for (my $i=0; $i<scalar(@name); $i++){
  print H "#define TAG_$name[$i]\t$i\n";
}



open (C,">$prefix.c") || die;
print C '#include "nalloc.h"',"\n";

print C join("", map ( $decl{$_} , @name));

print C "na_func na_jump_table[]={\n";
print C join(",\n", @name);
print C "\n};\n";
close C;

open (D,">$stubs.c") || die;
print D '#include <stdio.h>',"\n";
print D '#include "nalloc.h"',"\n";
print D join("", map ( $decl{$_} , @name));
foreach my $stub (@name){
  printf D '
void %s(na_node_p n, na_slot_t s){
  fprintf(stderr,"Undefined  callback %s called for node %%lx, slot %%d",
	  (ulong)n,s);
  abort();
}
', $stub,$stub;
}
close D;
