/**
 * @file   memalloc.c
 * @author David Bremner <bremner@unb.ca>
 * @date   Thu Apr  4 16:01:32 2002
 * 
 * @brief  A layer on top of malloc and friends. 
 * 
 */

#include <stddef.h>
#include <stdlib.h>
#ifdef HAVE_CONFIG_H
#include "util_config.h"
#endif
#ifdef USE_DMALLOC
#include <dmalloc.h>
#endif
#include "error_message.h"

static void *freelist_delete(size_t);

void memalloc_init(){
}

void *memalloc(size_t len){
  void *return_val;
  return_val=malloc(len);
  err_assert(return_val);
  return return_val;
}

void *memrealloc(void *p,size_t len){
  void *return_val;
  return_val=realloc(p,len);
  err_assert(return_val);
  return return_val;
}

void memfree(void *mem){
    free(mem); 
}

void *freelist_delete(size_t len){
  return NULL;
}
