/**
 * @file   scan.lex
 * @author David Bremner
 * @date   Fri Apr 19 16:35:15 2002
 * 
 * @brief  A simple scanner to read in e.g. lists of numbers.
 * 
 * 
 */

%{
#include "scan.h"
  long int scanint;
%}
D [0-9]
%%
-       {return SCAN_MINUS;}
{D}+	{ scanint=atol(scantext); return SCAN_INT; }
"\n"	{ return SCAN_EOL; }
[ \t]+          /* eat up whitespace */
.       { return SCAN_ERROR; } 
<<EOF>> { return SCAN_EOF; }
%%

int scanwrap(){
  return 1;
}
