use lib "../filter";
use PointSet;
use FacetList;
use Chirotope;

use FilterUtil qw(run_command);

$S=PointSet::read_topcom("P10.dat");

$E=$S->extremes();

$F=$E->facets();

@output=run_command("./nuoms 2>/dev/null",$E->facets()->mpc());
$errcount=0;

foreach $line (@output){
  my $chi = Chirotope::from_pm($line);

  if (!$chi->facets()->equal($F)){
    $errcount++;
    print "ERROR, boundary mismatch for $line";
    print $chi->facets()->mpc();
  }
}
print "$errcount total errors";


